#include <Arduino.h>
#include <ESPAsyncWebServer.h>
#include <SPIFFS.h>
#include <HCSR04.h>

const char* ssid     = "Livebox_xxxxx";
const char* password = "xxxxxxxxxxxxxxxxxxxxx"; 

const int led = 15;
int i = 0;

int dist ;
String hauteur ;
String pompe ;

#define TRIG_PIN 19
#define ECHO_PIN 23

UltraSonicDistanceSensor distanceSensor(TRIG_PIN,ECHO_PIN);  


AsyncWebServer server(80);


void Mesure()
{
  dist = distanceSensor.measureDistanceCm();
  dist= 155 - dist; //Hauteur de la cuve 155cm
  hauteur = String(dist);
  //Serial.println(hauteur);  
}
 
void setup()
{
  //----------------------------------------------------Serial
   Serial.begin(9600);
  //while(!serial){}    //pendant la phase de dev -> attend l'ouverture du moniteur serie

  Serial.println("\n");

  //----------------------------------------------------GPIO
  pinMode(led, OUTPUT);
  digitalWrite(led, HIGH);
  

  //----------------------------------------------------SPIFFS
  if(!SPIFFS.begin())
  {
    Serial.println("Erreur SPIFFS...");
    return;
  }

  File root = SPIFFS.open("/");
  File file = root.openNextFile();

  while(file)
  {
    Serial.print("File: ");
    Serial.println(file.name());
    file.close();
    file = root.openNextFile();
  }

  //----------------------------------------------------WIFI
  WiFi.begin(ssid, password);
	Serial.print("Tentative de connexion...");
	
	while(WiFi.status() != WL_CONNECTED)
	{
		Serial.print(".");
		delay(100);
	}
	
	Serial.println("\n");
	Serial.println("Connexion etablie!");
	Serial.print("Adresse IP: ");
	Serial.println(WiFi.localIP());

  //----------------------------------------------------SERVER
  server.on("/", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    request->send(SPIFFS, "/index.html", "text/html");
  });

  server.on("/w3.css", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    request->send(SPIFFS, "/w3.css", "text/css");
  });

  server.on("/script.js", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    request->send(SPIFFS, "/script.js", "text/javascript");
  });

  server.on("/schadock", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    request->send(SPIFFS, "/schadock.jpg", "image/jpeg");
  });

  server.on("/schadock2", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    request->send(SPIFFS, "/schadock2.gif", "image/gif");
  });




 server.on("/lireHauteur", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    Mesure();
    request->send(200, "text/plain", hauteur);
  });

  server.on("/on", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    digitalWrite(led, LOW);
    i=0;
    request->send(200);
  });

  server.on("/off", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    digitalWrite(led, HIGH);
    request->send(200);
  });

server.on("/etat", HTTP_GET, [](AsyncWebServerRequest *request)
  {
    pompe = String(digitalRead(led));
    request->send(200, "text/plain", pompe);
  });

  server.begin();
  Serial.println("Serveur actif!");
}


void loop()
{
	
  if(WiFi.status() != WL_CONNECTED)
	{
		delay(10000);
    if(WiFi.status() != WL_CONNECTED)
    {
      ESP.restart();
    }
    
	}
  
  
  
  Mesure();

  // Serial.println(dist);

  if(dist < 20){
    digitalWrite(led, HIGH);
  }

  if(pompe=="0"){
    i++;
   
    if (i>=600)   // delai de 10 minutes -> 600 *1000
    {
      digitalWrite(led, HIGH);
      i=0;
    }
    Serial.println(i);
  } 

  delay(1000);
}  